#ifndef __PSP_H__
#define __PSP_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*#define malloc malloc_psp
#define free free_psp
#define calloc calloc_psp
#define realloc realloc_psp
*/

#define RELEASE
#define SNAPSHOT_ACTIVE

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdio.h>
#include <stdlib.h>
//#include <unistd.h>
//#include <fcntl.h>
#include <string.h>
#include <math.h>

#include "pg.h"
#include "psplib.h"
//#include "malloc.h"

//#define memmove memmove_psp

void ErrorMsg(char *msg);

extern char launchDir[256];
extern char tmp_str[256];
  extern volatile int neogeo_soundmute;
  extern int neogeo_mp3_volume,psp_vsync,psp_cpuclock,neogeo_mp3_trackname,
    neogeo_mp3_errors,osd_background;

#define VRAM_ADDR	(0x04000000)

#define SCREEN_WIDTH	480
#define SCREEN_HEIGHT	272

#define POWER_CB_POWER		0x80000000 
#define POWER_CB_HOLDON		0x40000000 
#define POWER_CB_STANDBY	0x00080000 
#define POWER_CB_RESCOMP	0x00040000 
#define POWER_CB_RESUME		0x00020000 
#define POWER_CB_SUSPEND	0x00010000 
#define POWER_CB_EXT		0x00001000 
#define POWER_CB_BATLOW		0x00000100 
#define POWER_CB_BATTERY	0x00000080 
#define POWER_CB_BATTPOWER	0x0000007F 

#define MAX_PATH 256

  // These version major/minor are used to check the version of the ini file
  // if the version read in the ini file is > than the version in psp.h then
  // the read aborts. It's a very unlikely condition, but anyway...

#define VERSION_MAJOR 0
#define VERSION_MINOR 8

/* This changelog is mainly to remember the changes for the release.
 * See the web page for older changes.
 *
 * 0.8 :
 * - Fixed speed of animations (waterfall in blue's journey...)
 * - fixed voices too fast in art of fighting (and maybe some others)
 * - Fixed red and blue inverted when clearing the screen in hardware mode
 *   (it was producing a red sky in crossed swords, and a few bad colors in
 *    some other games).
 * - Some files were really intended not to be loaded in the neocd, such as
 *   these weird samples in aof, and another in neo turf master. Now they
 *   are correctly ignored.
 * - The rasterline interrupt is now emulated which enables playing art
 *   of fighting 2 at 115 or 130% (button B when starting a game)
 *   The raster effects are not yet emulated, the background in super
 *   sidekicks2 is now all green !
 * - A new gui from Radius !
 * - Added support for the fonts of the SDL_gfx project, and added a font
 *   selector to the new gui
 * - Fixed the crash in neogeo cd special
 * - Added more options than what anybody will ever need for the osd :
 *   you can now choose if you want to see or not mp3 tracks, mp3 errors,
 *   if you want a black or transparent background and I added a profiler
 *   display that you can choose from the "Show FPS" option. This profiler
 *   is mainly usefull to me to see where the emulation looses time, but you
 *   can try it if you are curious !
 *   All this is now in the "OSD..." menu.
 * - Acceleration : a basic optimization for the 68k handlers and I won about
 *   15 fps on the art of fighting main menu, and a trick on the raster
 *   counter helped me to win about 30 fps in ninja commando, and the hall
 *   of fame in magician lord (now maybe you don't have enough time to input
 *   your name in magician lord, oh well...)
 */

#define VERSION_STR "0.8"

int ExitCallback(int, int, void *);
void MP3Pause(int pause);
#ifndef RELEASE
void debug_log( const char* message );
#else
#define debug_log(message)
#endif
void StopSoundThread();
void InitSoundThread();
int PlayMP3(char *name);
void StopMP3();
int InitMP3Thread();
void StopMP3Thread();
void show_background(int fade);
int psp_ExitCheck();
void set_cpu_clock();
void print_center(char *msg);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __PSP_H__ */
