
#ifdef __cplusplus
extern "C" {
#endif
#ifndef AY8910_H
#define AY8910_H

#define MAX_8910 5
#define ALL_8910_CHANNELS -1

// #include "z80/cz80.h"

typedef u32(*mem_read_handler) (u32 offset);
typedef void (*mem_write_handler) (u32 offset, u32 data);

struct AY8910interface
{
	int num;	/* total number of 8910 in the machine */
	int baseclock;
	int mixing_level[MAX_8910];
    mem_read_handler portAread[MAX_8910];
    mem_read_handler portBread[MAX_8910];
    mem_write_handler portAwrite[MAX_8910];
    mem_write_handler portBwrite[MAX_8910];
	void (*handler[MAX_8910])(int irq);	/* IRQ handler for the YM2203 */
};

void AY8910_reset(int chip);

void AY8910_set_clock(int chip,int _clock);
void AY8910_set_volume(int chip,int channel,int volume);


void AY8910Write(int chip,int a,int data);
int AY8910Read(int chip);

  extern u32 ay8910_amplify;

void AY8910_control_port_0_w(u32 offset, u32 data);
void AY8910_control_port_1_w(u32 offset, u32 data);
void AY8910_control_port_2_w(u32 offset, u32 data);
void AY8910_control_port_3_w(u32 offset, u32 data);
void AY8910_control_port_4_w(u32 offset, u32 data);

void AY8910_write_port_0_w(u32 offset, u32 data);
void AY8910_write_port_1_w(u32 offset, u32 data);
void AY8910_write_port_2_w(u32 offset, u32 data);
void AY8910_write_port_3_w(u32 offset, u32 data);
void AY8910_write_port_4_w(u32 offset, u32 data);

int AY8910_sh_start(const struct AY8910interface *intf);
void AY8910_sh_stop(void);
void AY8910_sh_reset(void);

/*********** An interface for SSG of YM2203 ***********/

/* When both of AY8910 and YM2203 or YM2608 or YM2610 are used.      */
/* It must be called AY8910_sh_start () before AY8910_sh_start_ym()  */

extern int ay8910_index_ym;

void AY8910_sh_stop_ym(void);
int AY8910_sh_start_ym(const struct AY8910interface *intf);

int AY8910_get_stream_num( int chip );

#endif

#ifdef __cplusplus
}
#endif
